<?php

namespace Axepta\Paywall\Model\Sales;

use Magento\Catalog\Api\ProductRepositoryInterface;
use Magento\Catalog\Model\Product\Visibility;
use Magento\Catalog\Model\ResourceModel\Product\CollectionFactory;
use Magento\Directory\Model\CurrencyFactory;
use Magento\Eav\Model\Config;
use Magento\Framework\Api\AttributeValueFactory;
use Magento\Framework\Api\ExtensionAttributesFactory;
use Magento\Framework\Data\Collection\AbstractDb;
use Magento\Framework\Model\Context;
use Magento\Framework\Model\ResourceModel\AbstractResource;
use Magento\Framework\Pricing\PriceCurrencyInterface;
use Magento\Framework\Registry;
use Magento\Framework\Stdlib\DateTime\TimezoneInterface;
use Magento\Sales\Api\InvoiceManagementInterface;
use Magento\Sales\Model\Order\Status\HistoryFactory;
use Magento\Store\Model\StoreManagerInterface;

/**
 * Class Order
 *
 * @package Axepta\Paywall\Model\Sales
 */
class Order extends \Magento\Sales\Model\Order
{
	/**
	 * Order constructor.
	 *
	 * @param Context                                          $context
	 * @param Registry                                               $registry
	 * @param ExtensionAttributesFactory                         $extensionFactory
	 * @param AttributeValueFactory                              $customAttributeFactory
	 * @param TimezoneInterface                      $timezone
	 * @param StoreManagerInterface                                $storeManager
	 * @param \Magento\Sales\Model\Order\Config                                         $orderConfig
	 * @param ProductRepositoryInterface                           $productRepository
	 * @param \Magento\Sales\Model\ResourceModel\Order\Item\CollectionFactory           $orderItemCollectionFactory
	 * @param Visibility                                 $productVisibility
	 * @param InvoiceManagementInterface                             $invoiceManagement
	 * @param CurrencyFactory                                  $currencyFactory
	 * @param Config                                                 $eavConfig
	 * @param HistoryFactory                          $orderHistoryFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Address\CollectionFactory        $addressCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Payment\CollectionFactory        $paymentCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Status\History\CollectionFactory $historyCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Invoice\CollectionFactory        $invoiceCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Shipment\CollectionFactory       $shipmentCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Creditmemo\CollectionFactory     $memoCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\Shipment\Track\CollectionFactory $trackCollectionFactory
	 * @param \Magento\Sales\Model\ResourceModel\Order\CollectionFactory                $salesOrderCollectionFactory
	 * @param PriceCurrencyInterface                         $priceCurrency
	 * @param CollectionFactory            $productListFactory
	 * @param AbstractResource|null              $resource
	 * @param AbstractDb|null                        $resourceCollection
	 * @param array                                                                     $data
	 */
	public function __construct(
		Context $context,
		Registry $registry,
		ExtensionAttributesFactory $extensionFactory,
		AttributeValueFactory $customAttributeFactory,
		TimezoneInterface $timezone,
		StoreManagerInterface $storeManager,
		\Magento\Sales\Model\Order\Config $orderConfig,
		ProductRepositoryInterface $productRepository,
		\Magento\Sales\Model\ResourceModel\Order\Item\CollectionFactory $orderItemCollectionFactory,
		Visibility $productVisibility,
		InvoiceManagementInterface $invoiceManagement,
		CurrencyFactory $currencyFactory,
		Config $eavConfig,
		HistoryFactory $orderHistoryFactory,
		\Magento\Sales\Model\ResourceModel\Order\Address\CollectionFactory $addressCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\Payment\CollectionFactory $paymentCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\Status\History\CollectionFactory $historyCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\Invoice\CollectionFactory $invoiceCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\Shipment\CollectionFactory $shipmentCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\Creditmemo\CollectionFactory $memoCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\Shipment\Track\CollectionFactory $trackCollectionFactory,
		\Magento\Sales\Model\ResourceModel\Order\CollectionFactory $salesOrderCollectionFactory,
		PriceCurrencyInterface $priceCurrency,
		CollectionFactory $productListFactory,
		AbstractResource $resource = null,
		AbstractDb $resourceCollection = null,
		array $data = []
	) {
		parent::__construct(
			$context,
			$registry,
			$extensionFactory,
			$customAttributeFactory,
			$timezone,
			$storeManager,
			$orderConfig,
			$productRepository,
			$orderItemCollectionFactory,
			$productVisibility,
			$invoiceManagement,
			$currencyFactory,
			$eavConfig,
			$orderHistoryFactory,
			$addressCollectionFactory,
			$paymentCollectionFactory,
			$historyCollectionFactory,
			$invoiceCollectionFactory,
			$shipmentCollectionFactory,
			$memoCollectionFactory,
			$trackCollectionFactory,
			$salesOrderCollectionFactory,
			$priceCurrency,
			$productListFactory,
			$resource,
			$resourceCollection,
			$data
		);
	}
}
